<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleSquatToStand_answers.py</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleSquatToStand_answers_8py-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleSquatToStand_answers.py</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example that predicts a squat-to-stand movement and optimizes the stiffness of an assistive passive device.</p>
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">import</span> opensim <span class="keyword">as</span> osim</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">import</span> exampleSquatToStand_helpers <span class="keyword">as</span> helpers</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">import</span> mocoPlotTrajectory <span class="keyword">as</span> plot</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">import</span> os</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">import</span> numpy <span class="keyword">as</span> np</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;torqueDrivenModel = helpers.getTorqueDrivenModel()</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;muscleDrivenModel = helpers.getMuscleDrivenModel()</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;study = osim.MocoStudy()</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"># Part 1b: Initialize the problem and set the model.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;problem = study.updProblem()</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;problem.setModel(torqueDrivenModel)</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"># Part 1c: Set bounds on the problem.</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"># problem.setTimeBounds(initial_bounds, final_bounds)</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"># problem.setStateInfo(path, trajectory_bounds, inital_bounds, final_bounds)</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"># All *_bounds arguments can be set to a range, [lower upper], or to a</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"># single value (equal lower and upper bounds). Empty brackets, [], indicate</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"># using default bounds (if they exist). You may set multiple state infos at</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"># once using setStateInfoPattern():</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"># problem.setStateInfoPattern(pattern, trajectory_bounds, inital_bounds, ...</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment">#       final_bounds)</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"># This function supports regular expressions in the &#39;pattern&#39; argument;</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"># use &#39;.*&#39; to match any substring of the state/control path</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"># For example, the following will set all coordinate value state infos:</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"># problem.setStateInfoPattern(&#39;/path/to/states/.*/value&#39;, ...)</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"># Time bounds</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;problem.setTimeBounds(0, 1)</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"># Position bounds: the model should start in a squat and finish </span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"># standing up.</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;problem.setStateInfo(<span class="stringliteral">&#39;/jointset/hip_r/hip_flexion_r/value&#39;</span>, </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    [-2, 0.5], -2, 0)</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;problem.setStateInfo(<span class="stringliteral">&#39;/jointset/knee_r/knee_angle_r/value&#39;</span>, </div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    [-2, 0], -2, 0)</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;problem.setStateInfo(<span class="stringliteral">&#39;/jointset/ankle_r/ankle_angle_r/value&#39;</span>, </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    [-0.5, 0.7], -0.5, 0)</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="comment"># Velocity bounds: all model coordinates should start and end at rest.</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;problem.setStateInfoPattern(<span class="stringliteral">&#39;/jointset/.*/speed&#39;</span>, [], 0, 0)</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment"># Part 1d: Add a MocoControlCost to the problem.</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;problem.addGoal(osim.MocoControlGoal(<span class="stringliteral">&#39;myeffort&#39;</span>))</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment"># Part 1e: Configure the solver.</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;solver = study.initCasADiSolver()</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;solver.set_num_mesh_intervals(25)</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;solver.set_optim_convergence_tolerance(1e-4)</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;solver.set_optim_constraint_tolerance(1e-4)</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keywordflow">if</span> <span class="keywordflow">not</span> os.path.isfile(<span class="stringliteral">&#39;predictSolution.sto&#39;</span>):</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="comment"># Part 1f: Solve! Write the solution to file, and visualize.</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    predictSolution = study.solve()</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    predictSolution.write(<span class="stringliteral">&#39;predictSolution.sto&#39;</span>)</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    study.visualize(predictSolution)</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160; </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;tableProcessor = osim.TableProcessor(<span class="stringliteral">&#39;predictSolution.sto&#39;</span>)</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;tableProcessor.append(osim.TabOpLowPassFilter(6))</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment"># Part 2b: Add a MocoStateTrackingCost to the problem using the states</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="comment"># from the predictive problem (via the TableProcessor we just created). </span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment"># Enable the setAllowUnusedReferences() setting to ignore the controls in</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment"># the predictive solution.</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;tracking = osim.MocoStateTrackingGoal()</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;tracking.setName(<span class="stringliteral">&#39;mytracking&#39;</span>)</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;tracking.setReference(tableProcessor)</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;tracking.setAllowUnusedReferences(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;problem.addGoal(tracking)</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160; </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="comment"># Part 2c: Reduce the control cost weight so it now acts as a regularization </span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment"># term.</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;problem.updGoal(<span class="stringliteral">&#39;myeffort&#39;</span>).setWeight(0.001)</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160; </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment"># Part 2d: Set the initial guess using the predictive problem solution.</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="comment"># Tighten convergence tolerance to ensure smooth controls.</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;solver.setGuessFile(<span class="stringliteral">&#39;predictSolution.sto&#39;</span>)</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;solver.set_optim_convergence_tolerance(1e-6)</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="keywordflow">if</span> <span class="keywordflow">not</span> os.path.isfile(<span class="stringliteral">&#39;trackingSolution.sto&#39;</span>):</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="comment"># Part 2e: Solve! Write the solution to file, and visualize.</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    trackingSolution = study.solve()</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    trackingSolution.write(<span class="stringliteral">&#39;trackingSolution.sto&#39;</span>)</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    study.visualize(trackingSolution)</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160; </div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160; </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160; </div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;plot.mocoPlotTrajectory(<span class="stringliteral">&#39;predictSolution.sto&#39;</span>, <span class="stringliteral">&#39;trackingSolution.sto&#39;</span>, </div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="stringliteral">&#39;predict&#39;</span>, <span class="stringliteral">&#39;track&#39;</span>)</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160; </div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160; </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;inverse = osim.MocoInverse()</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="comment"># Part 4a: Provide the model via a ModelProcessor. Similar to the TableProcessor,</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="comment"># you can add operators to modify the base model.</span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;modelProcessor = osim.ModelProcessor(muscleDrivenModel)</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;modelProcessor.append(osim.ModOpAddReserves(2))</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;inverse.setModel(modelProcessor)</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160; </div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="comment"># Part 4b: Set the reference kinematics using the same TableProcessor we used</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="comment"># in the tracking problem.</span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;inverse.setKinematics(tableProcessor)</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="comment"># Part 4c: Set the time range, mesh interval, and convergence tolerance.</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;inverse.set_initial_time(0)</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;inverse.set_final_time(1)</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;inverse.set_mesh_interval(0.05)</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;inverse.set_convergence_tolerance(1e-4)</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;inverse.set_constraint_tolerance(1e-4)</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160; </div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="comment"># Allow extra (unused) columns in the kinematics and minimize activations.</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;inverse.set_kinematics_allow_extra_columns(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;inverse.set_minimize_sum_squared_activations(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160; </div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="comment"># Append additional outputs path for quantities that are calculated</span></div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="comment"># post-hoc using the inverse problem solution.</span></div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;inverse.append_output_paths(<span class="stringliteral">&#39;.*normalized_fiber_length&#39;</span>)</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;inverse.append_output_paths(<span class="stringliteral">&#39;.*passive_force_multiplier&#39;</span>)</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160; </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="comment"># Part 4d: Solve! Write the MocoSolution to file.</span></div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;inverseSolution = inverse.solve()</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;solution = inverseSolution.getMocoSolution()</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;solution.write(<span class="stringliteral">&#39;inverseSolution.sto&#39;</span>)</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="comment"># Part 4e: Get the outputs we calculated from the inverse solution.</span></div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;inverseOutputs = inverseSolution.getOutputs()</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;sto = osim.STOFileAdapter()</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;sto.write(inverseOutputs, <span class="stringliteral">&#39;muscleOutputs.sto&#39;</span>)</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160; </div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;device = osim.SpringGeneralizedForce(<span class="stringliteral">&#39;knee_angle_r&#39;</span>)</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;device.setStiffness(50)</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;device.setRestLength(0)</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;device.setViscosity(0)</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;muscleDrivenModel.addForce(device)</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160; </div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="comment"># Part 5b: Create a ModelProcessor similar to the previous one, using the same</span></div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="comment"># reserve actuator strength so we can compare muscle activity accurately.</span></div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;modelProcessor = osim.ModelProcessor(muscleDrivenModel)</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;modelProcessor.append(osim.ModOpAddReserves(2))</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;inverse.setModel(modelProcessor)</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160; </div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="comment"># Part 5c: Solve! Write solution.</span></div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;inverseDeviceSolution = inverse.solve()</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;deviceSolution = inverseDeviceSolution.getMocoSolution()</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;deviceSolution.write(<span class="stringliteral">&#39;inverseDeviceSolution.sto&#39;</span>)</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160; </div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160; </div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;print(<span class="stringliteral">&#39;Cost without device: &#39;</span>, solution.getObjective())</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;print(<span class="stringliteral">&#39;Cost with device: &#39;</span>, deviceSolution.getObjective())</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160; </div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;<span class="comment"># This is a convenience function provided for you. See below for the</span></div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="comment"># implementation.</span></div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;helpers.compareInverseSolutions(inverseSolution, inverseDeviceSolution)</div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
